diff --git a/src/modules/OpenSLES/OpenSLESWriter.hpp b/src/modules/OpenSLES/OpenSLESWriter.hpp
index 13f6b775..673cadab 100644
--- a/src/modules/OpenSLES/OpenSLESWriter.hpp
+++ b/src/modules/OpenSLES/OpenSLESWriter.hpp
@@ -24,24 +24,24 @@
 
 #include <SLES/OpenSLES.h>
 
-class OpenSLESWriter final : public Writer
+class OpenSLESWriter : public Writer
 {
 public:
     OpenSLESWriter(Module &);
 private:
         ~OpenSLESWriter();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
-    qint64 write(const QByteArray &) override;
-    void pause() override;
+    bool processParams(bool *paramsCorrected);
+    qint64 write(const QByteArray &);
+    void pause();
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
     /**/
 
diff --git a/src/modules/PipeWire/PipeWire.hpp b/src/modules/PipeWire/PipeWire.hpp
index ee5b717e..9dafbe98 100644
--- a/src/modules/PipeWire/PipeWire.hpp
+++ b/src/modules/PipeWire/PipeWire.hpp
@@ -20,17 +20,17 @@
 
 #include <Module.hpp>
 
-class PipeWire final : public Module
+class PipeWire : public Module
 {
 public:
     PipeWire();
     ~PipeWire();
 
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -39,7 +39,7 @@ private:
 
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 
@@ -48,7 +48,7 @@ public:
     ~ModuleSettingsWidget();
 
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *m_enabledCheckBox;
 };
diff --git a/src/modules/PipeWire/PipeWireWriter.hpp b/src/modules/PipeWire/PipeWireWriter.hpp
index e061c20f..2bb46fcc 100644
--- a/src/modules/PipeWire/PipeWireWriter.hpp
+++ b/src/modules/PipeWire/PipeWireWriter.hpp
@@ -28,7 +28,7 @@
 #include <spa/param/audio/format-utils.h>
 #include <pipewire/pipewire.h>
 
-class PipeWireWriter final : public Writer
+class PipeWireWriter : public Writer
 {
     Q_DECLARE_TR_FUNCTIONS(PipeWireWriter)
 
@@ -37,18 +37,18 @@ public:
     ~PipeWireWriter();
 
 private:
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
-    qint64 write(const QByteArray &) override;
+    bool processParams(bool *paramsCorrected);
+    qint64 write(const QByteArray &);
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
-    void pause() override;
+    void pause();
 
 private:
     void onCoreEventDone(uint32_t id, int seq);
diff --git a/src/modules/Playlists/M3U.cpp b/src/modules/Playlists/M3U.cpp
index 1ac38d83..fa969990 100644
--- a/src/modules/Playlists/M3U.cpp
+++ b/src/modules/Playlists/M3U.cpp
@@ -100,19 +100,19 @@ bool M3U::write(const Entries &list)
 #endif
             }
             writer->write(QString("#EXTINF:" + length + "," + QString(entry.name).replace('\n', '\001') + "\r\n").toUtf8());
-            for (auto it = entry.params.cbegin(), itEnd = entry.params.cend(); it != itEnd; ++it)
+            for (auto it = entry.params.constBegin(), itEnd = entry.params.constEnd(); it != itEnd; ++it)
             {
                 const auto &key = it.key();
                 if (key == Playlist::Entry::UserAgentParam)
                 {
-                    writer->write(QStringLiteral("#EXTVLCOPT:http-user-agent=%1\r\n").arg(QString(it.value().trimmed())).toUtf8());
+                    writer->write(QString("#EXTVLCOPT:http-user-agent=%1\r\n").arg(QString(it.value().trimmed())).toUtf8());
                 }
                 else if (key == Playlist::Entry::ReferrerParam)
                 {
-                    writer->write(QStringLiteral("#EXTVLCOPT:http-referrer=%1\r\n").arg(QString(it.value().trimmed())).toUtf8());
+                    writer->write(QString("#EXTVLCOPT:http-referrer=%1\r\n").arg(QString(it.value().trimmed())).toUtf8());
                 }
             }
-            writer->write((url + "\r\n").toUtf8());
+            writer->write(QString(url + "\r\n").toUtf8());
         }
     }
     return true;
diff --git a/src/modules/Playlists/M3U.hpp b/src/modules/Playlists/M3U.hpp
index 15ffb7c0..6c03f5b3 100644
--- a/src/modules/Playlists/M3U.hpp
+++ b/src/modules/Playlists/M3U.hpp
@@ -20,10 +20,10 @@
 
 #include <Playlist.hpp>
 
-class M3U final : public Playlist
+class M3U : public Playlist
 {
-    Entries read() override;
-    bool write(const Entries &) override;
+    Entries read();
+    bool write(const Entries &);
 };
 
 #define M3UName "M3U"
diff --git a/src/modules/Playlists/PLS.cpp b/src/modules/Playlists/PLS.cpp
index 3bfd3692..4f7688bc 100644
--- a/src/modules/Playlists/PLS.cpp
+++ b/src/modules/Playlists/PLS.cpp
@@ -157,8 +157,8 @@ bool PLS::write(const Entries &list)
             writer->write(QString("QMPlay_GID" + idx + "=" + QString::number(entry.GID) + "\r\n").toUtf8());
         if (entry.parent)
             writer->write(QString("QMPlay_parent" + idx + "=" + QString::number(entry.parent) + "\r\n").toUtf8());
-        for (auto it = entry.params.cbegin(), itEnd = entry.params.cend(); it != itEnd; ++it)
-            writer->write(QStringLiteral("QMPlay_param_%1%2=%3\r\n").arg(QString(it.key())).arg(idx).arg(QString(it.value().trimmed())).toUtf8());
+        for (auto it = entry.params.constBegin(), itEnd = entry.params.constEnd(); it != itEnd; ++it)
+            writer->write(QString("QMPlay_param_%1%2=%3\r\n").arg(QString(it.key())).arg(idx).arg(QString(it.value().trimmed())).toUtf8());
     }
     return true;
 }
diff --git a/src/modules/Playlists/PLS.hpp b/src/modules/Playlists/PLS.hpp
index f1194ea0..3377e446 100644
--- a/src/modules/Playlists/PLS.hpp
+++ b/src/modules/Playlists/PLS.hpp
@@ -20,10 +20,10 @@
 
 #include <Playlist.hpp>
 
-class PLS final : public Playlist
+class PLS : public Playlist
 {
-    Entries read() override;
-    bool write(const Entries &) override;
+    Entries read();
+    bool write(const Entries &);
 };
 
 #define PLSName "PLS"
diff --git a/src/modules/Playlists/Playlists.hpp b/src/modules/Playlists/Playlists.hpp
index e38b8a0d..3b3a3e15 100644
--- a/src/modules/Playlists/Playlists.hpp
+++ b/src/modules/Playlists/Playlists.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class Playlists final : public Module
+class Playlists : public Module
 {
 public:
     Playlists();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -37,13 +37,13 @@ private:
 
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *m3uEnabledB, *xspfEnabledB;
 };
diff --git a/src/modules/Playlists/XSPF.cpp b/src/modules/Playlists/XSPF.cpp
index e829d80b..bed8766c 100644
--- a/src/modules/Playlists/XSPF.cpp
+++ b/src/modules/Playlists/XSPF.cpp
@@ -52,42 +52,42 @@ Playlist::Entries XSPF::read()
         switch (token)
         {
             case QXmlStreamReader::StartElement:
-                if (name == QStringLiteral("track"))
+                if (name == QString("track"))
                     inTrack = true;
                 else if (inTrack)
                 {
-                    if (name == QStringLiteral("extension"))
+                    if (name == QString("extension"))
                     {
-                        if (xmlReader.attributes().value("application") == QStringLiteral("QMPlay2"))
+                        if (xmlReader.attributes().value("application") == QString("QMPlay2"))
                             inExtension = true;
                     }
                     else
                     {
                         const QString value = xmlReader.readElementText();
-                        if (name == QStringLiteral("location"))
+                        if (name == QString("location"))
                             curr.url = Functions::Url(QUrl::fromPercentEncoding(value.toUtf8()), playlistPath);
-                        else if (name == QStringLiteral("title"))
+                        else if (name == QString("title"))
                             curr.name = value;
-                        else if (name == QStringLiteral("duration"))
+                        else if (name == QString("duration"))
                             curr.length = value.toInt() / 1000.0;
                         if (inExtension)
                         {
-                            if (name == QStringLiteral("f"))
+                            if (name == QString("f"))
                                 curr.flags = value.toInt();
-                            else if (name == QStringLiteral("q"))
+                            else if (name == QString("q"))
                                 curr.queue = value.toInt();
-                            else if (name == QStringLiteral("g"))
+                            else if (name == QString("g"))
                                 curr.GID = value.toInt();
-                            else if (name == QStringLiteral("p"))
+                            else if (name == QString("p"))
                                 curr.parent = value.toInt();
                         }
                     }
                 }
                 break;
             case QXmlStreamReader::EndElement:
-                if (name == QStringLiteral("extension"))
+                if (name == QString("extension"))
                     inExtension = false;
-                else if (name == QStringLiteral("track"))
+                else if (name == QString("track"))
                 {
                     if (inTrack)
                     {
diff --git a/src/modules/Playlists/XSPF.hpp b/src/modules/Playlists/XSPF.hpp
index 57dd6c51..5b58cf94 100644
--- a/src/modules/Playlists/XSPF.hpp
+++ b/src/modules/Playlists/XSPF.hpp
@@ -20,10 +20,10 @@
 
 #include <Playlist.hpp>
 
-class XSPF final : public Playlist
+class XSPF : public Playlist
 {
-    Entries read() override;
-    bool write(const Entries &) override;
+    Entries read();
+    bool write(const Entries &);
 };
 
 #define XSPFName "XSPF"
diff --git a/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h b/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h
index 8ddf0b10..6f90cf14 100644
--- a/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h
+++ b/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h
@@ -59,7 +59,12 @@
 #        define __MAC_10_11 101100
 #    endif
 #    ifndef QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE
-#        define QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE QT_OSX_PLATFORM_SDK_EQUAL_OR_ABOVE
+#        if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+#            define QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE QT_OSX_PLATFORM_SDK_EQUAL_OR_ABOVE
+#        else
+#            // Qt4: Always use deprecated API on older systems
+#            define QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE(x) 0
+#        endif
 #    endif
 #    if !QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE(__MAC_10_11)
 #        define DEPRECATED_LISTENER_API
diff --git a/src/modules/PortAudio/PortAudio.cpp b/src/modules/PortAudio/PortAudio.cpp
index 7bf87004..def696b8 100644
--- a/src/modules/PortAudio/PortAudio.cpp
+++ b/src/modules/PortAudio/PortAudio.cpp
@@ -25,7 +25,7 @@ PortAudio::PortAudio() :
     m_icon = QIcon(":/PortAudio.svgz");
 
     init("WriterEnabled", true);
-#if defined(Q_OS_MACOS)
+#if defined(Q_OS_MAC)
     init("Delay", 0.03);
     init("BitPerfect", false);
 #elif defined(Q_OS_WIN)
@@ -92,7 +92,7 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module) :
     m_exclusive->setChecked(sets().getBool("Exclusive"));
 #endif
 
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     bitPerfect = new QCheckBox(tr("Bit-perfect audio"));
     bitPerfect->setChecked(sets().getBool("BitPerfect"));
     bitPerfect->setToolTip(tr("This sets the selected output device to the sample rate of the content being played"));
@@ -105,7 +105,7 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module) :
 #ifdef Q_OS_WIN
     layout->addRow(m_exclusive);
 #endif
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     layout->addRow(bitPerfect);
 #endif
 }
@@ -118,7 +118,7 @@ void ModuleSettingsWidget::saveSettings()
 #ifdef Q_OS_WIN
     sets().set("Exclusive", m_exclusive->isChecked());
 #endif
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     sets().set("BitPerfect", bitPerfect->isChecked());
 #endif
 }
diff --git a/src/modules/PortAudio/PortAudio.hpp b/src/modules/PortAudio/PortAudio.hpp
index fd8c821b..9c16e890 100644
--- a/src/modules/PortAudio/PortAudio.hpp
+++ b/src/modules/PortAudio/PortAudio.hpp
@@ -20,17 +20,17 @@
 
 #include <Module.hpp>
 
-class PortAudio final : public Module
+class PortAudio : public Module
 {
 public:
     PortAudio();
     ~PortAudio();
 
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -41,7 +41,7 @@ class QDoubleSpinBox;
 class QCheckBox;
 class QComboBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 
@@ -49,7 +49,7 @@ public:
     ModuleSettingsWidget(Module &);
 
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *enabledB;
     QComboBox *devicesB;
@@ -57,7 +57,7 @@ private:
 #ifdef Q_OS_WIN
     QCheckBox *m_exclusive;
 #endif
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     QCheckBox *bitPerfect;
 #endif
 };
diff --git a/src/modules/PortAudio/PortAudioWriter.cpp b/src/modules/PortAudio/PortAudioWriter.cpp
index e2438c2e..8da43333 100644
--- a/src/modules/PortAudio/PortAudioWriter.cpp
+++ b/src/modules/PortAudio/PortAudioWriter.cpp
@@ -27,7 +27,7 @@
 #   include <audioclient.h>
 #endif
 
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     #include "3rdparty/CoreAudio/AudioDeviceList.h"
     #include "3rdparty/CoreAudio/AudioDevice.h"
 #endif
@@ -124,7 +124,7 @@ PortAudioWriter::~PortAudioWriter()
 #ifdef Q_OS_WIN
     delete m_wasapiNotifications;
 #endif
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     delete m_coreAudioDevice;
 #endif
     if (m_initialized)
@@ -154,7 +154,7 @@ bool PortAudioWriter::set()
         restartPlaying = true;
     }
 #endif
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     const bool bitPerfect = sets().getBool("BitPerfect");
 #endif
     if (m_outputDevice != newOutputDevice)
@@ -167,7 +167,7 @@ bool PortAudioWriter::set()
         m_outputParameters.suggestedLatency = delay;
         restartPlaying = true;
     }
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     if (m_bitPerfect != bitPerfect)
     {
         m_bitPerfect = bitPerfect;
@@ -297,9 +297,9 @@ QString PortAudioWriter::name() const
         if (m_exclusive)
             name += QString(", %1Hz").arg(m_sampleRate);
 #endif
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
         if (m_coreAudioDevice)
-            name += QStringLiteral(", %1Hz").arg(m_coreAudioDevice->CurrentNominalSampleRate());
+            name += QString(", %1Hz").arg(m_coreAudioDevice->CurrentNominalSampleRate());
 #endif
     }
     return name;
@@ -389,7 +389,7 @@ bool PortAudioWriter::openStream()
         }
 #endif
 
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
         if (m_bitPerfect)
         {
             const QString devName(Pa_GetDeviceInfo(m_outputParameters.device)->name);
@@ -496,7 +496,7 @@ void PortAudioWriter::close()
         Pa_CloseStream(m_stream);
         m_stream = nullptr;
     }
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     if (m_coreAudioDevice)
         m_coreAudioDevice->ResetNominalSampleRate();
 #endif
diff --git a/src/modules/PortAudio/PortAudioWriter.hpp b/src/modules/PortAudio/PortAudioWriter.hpp
index 1fc3f311..564c0a10 100644
--- a/src/modules/PortAudio/PortAudioWriter.hpp
+++ b/src/modules/PortAudio/PortAudioWriter.hpp
@@ -35,23 +35,23 @@
 #ifdef Q_OS_WIN
 class PortAudioWriter;
 
-class WASAPINotifications final : public IMMNotificationClient
+class WASAPINotifications : public IMMNotificationClient
 {
 public:
     WASAPINotifications(PortAudioWriter *writer);
     ~WASAPINotifications();;
 
 private:
-    HRESULT STDMETHODCALLTYPE OnDeviceStateChanged(LPCWSTR pwstrDeviceId, DWORD dwNewState) override;
-    HRESULT STDMETHODCALLTYPE OnDeviceAdded(LPCWSTR pwstrDeviceId) override;
-    HRESULT STDMETHODCALLTYPE OnDeviceRemoved(LPCWSTR pwstrDeviceId) override;
-    HRESULT STDMETHODCALLTYPE OnDefaultDeviceChanged(EDataFlow flow, ERole role, LPCWSTR pwstrDeviceId) override;
-    HRESULT STDMETHODCALLTYPE OnPropertyValueChanged(LPCWSTR pwstrDeviceId, const PROPERTYKEY key) override;
+    HRESULT STDMETHODCALLTYPE OnDeviceStateChanged(LPCWSTR pwstrDeviceId, DWORD dwNewState);
+    HRESULT STDMETHODCALLTYPE OnDeviceAdded(LPCWSTR pwstrDeviceId);
+    HRESULT STDMETHODCALLTYPE OnDeviceRemoved(LPCWSTR pwstrDeviceId);
+    HRESULT STDMETHODCALLTYPE OnDefaultDeviceChanged(EDataFlow flow, ERole role, LPCWSTR pwstrDeviceId);
+    HRESULT STDMETHODCALLTYPE OnPropertyValueChanged(LPCWSTR pwstrDeviceId, const PROPERTYKEY key);
 
 private:
-    HRESULT STDMETHODCALLTYPE QueryInterface(const IID &iid, void **ppUnk) override;
-    ULONG STDMETHODCALLTYPE AddRef() override;
-    ULONG STDMETHODCALLTYPE Release() override;
+    HRESULT STDMETHODCALLTYPE QueryInterface(const IID &iid, void **ppUnk);
+    ULONG STDMETHODCALLTYPE AddRef();
+    ULONG STDMETHODCALLTYPE Release();
 
 private:
     PortAudioWriter *const m_writer;
@@ -59,11 +59,11 @@ private:
 };
 #endif
 
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
 class AudioDevice;
 #endif
 
-class PortAudioWriter final : public Writer
+class PortAudioWriter : public Writer
 {
     Q_DECLARE_TR_FUNCTIONS(PortAudioWriter)
 
@@ -72,17 +72,17 @@ public:
 private:
     ~PortAudioWriter();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
-    qint64 write(const QByteArray &) override;
-    void pause() override;
+    bool processParams(bool *paramsCorrected);
+    qint64 write(const QByteArray &);
+    void pause();
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
 private:
     bool deviceNeedsChangeParams(int *newChn = nullptr, int *newRate = nullptr);
@@ -124,7 +124,7 @@ private:
     QString m_paDefaultDeviceId;
     QString m_defaultDeviceId;
 #endif
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     bool m_bitPerfect = false;
     AudioDevice *m_coreAudioDevice = nullptr;
 #endif
diff --git a/src/modules/PulseAudio/PulseAudio.hpp b/src/modules/PulseAudio/PulseAudio.hpp
index f875e2b8..3847ca4f 100644
--- a/src/modules/PulseAudio/PulseAudio.hpp
+++ b/src/modules/PulseAudio/PulseAudio.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class PulseAudio final : public Module
+class PulseAudio : public Module
 {
 public:
     PulseAudio();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -38,13 +38,13 @@ private:
 class QDoubleSpinBox;
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *enabledB;
     QDoubleSpinBox *delayB;
diff --git a/src/modules/PulseAudio/PulseAudioWriter.hpp b/src/modules/PulseAudio/PulseAudioWriter.hpp
index a82e60ad..3a7fda45 100644
--- a/src/modules/PulseAudio/PulseAudioWriter.hpp
+++ b/src/modules/PulseAudio/PulseAudioWriter.hpp
@@ -23,23 +23,23 @@
 
 #include <QCoreApplication>
 
-class PulseAudioWriter final : public Writer
+class PulseAudioWriter : public Writer
 {
     Q_DECLARE_TR_FUNCTIONS(PulseAudioWriter)
 public:
     PulseAudioWriter(Module &);
     ~PulseAudioWriter();
 private:
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
-    qint64 write(const QByteArray &) override;
+    bool processParams(bool *paramsCorrected);
+    qint64 write(const QByteArray &);
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
     /**/
 
diff --git a/src/modules/QPainter/QPainter.hpp b/src/modules/QPainter/QPainter.hpp
index e4f93511..e942feb6 100644
--- a/src/modules/QPainter/QPainter.hpp
+++ b/src/modules/QPainter/QPainter.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class QPainterSW final : public Module
+class QPainterSW : public Module
 {
 public:
     QPainterSW();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -37,13 +37,13 @@ private:
 
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *enabledB;
 };
diff --git a/src/modules/QPainter/QPainterWriter.cpp b/src/modules/QPainter/QPainterWriter.cpp
index b3e2c8e2..ba0ccd7e 100644
--- a/src/modules/QPainter/QPainterWriter.cpp
+++ b/src/modules/QPainter/QPainterWriter.cpp
@@ -39,7 +39,12 @@ Drawable::Drawable(QPainterWriter &writer) :
     setPalette(Qt::black);
 }
 Drawable::~Drawable()
-{}
+{
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+    if (imgData)
+        av_free(imgData);
+#endif
+}
 
 void Drawable::draw(const Frame &newVideoFrame, bool canRepaint, bool entireScreen)
 {
@@ -54,10 +59,18 @@ void Drawable::draw(const Frame &newVideoFrame, bool canRepaint, bool entireScre
     if (imgScaler.create(videoFrame, m_scaleByQt ? -1 : imgW, m_scaleByQt ? -1 : imgH))
     {
         auto createImg = [this](int w, int h) {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             auto imgData = reinterpret_cast<uint8_t *>(av_malloc(w * h * 4 + av_cpu_max_align()));
             img = QImage(imgData, w, h, QImage::Format_RGB32, [](void *ptr) {
                 av_free(ptr);
             }, imgData);
+#else
+            // Qt4: Manual memory management
+            if (imgData)
+                av_free(imgData);
+            imgData = reinterpret_cast<uint8_t *>(av_malloc(w * h * 4 + av_cpu_max_align()));
+            img = QImage(imgData, w, h, QImage::Format_RGB32);
+#endif
         };
         if (m_scaleByQt && (img.width() != videoFrame.width() || img.height() != videoFrame.height()))
         {
@@ -81,7 +94,13 @@ void Drawable::draw(const Frame &newVideoFrame, bool canRepaint, bool entireScre
 
 void Drawable::resizeEvent(QResizeEvent *e)
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 6, 0)
     const qreal dpr = devicePixelRatioF();
+#elif QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    const qreal dpr = devicePixelRatio();
+#else
+    const qreal dpr = 1.0; // Qt4: No device pixel ratio support
+#endif
     Functions::getImageSize(writer.aspect_ratio, writer.zoom, width(), height(), W, H, &X, &Y);
     Functions::getImageSize(writer.aspect_ratio, writer.zoom, width() * dpr, height() * dpr, imgW, imgH);
 
@@ -101,7 +120,13 @@ void Drawable::paintEvent(QPaintEvent *)
 
     if (!osd_list.isEmpty())
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 6, 0)
         const qreal dpr = devicePixelRatioF();
+#elif QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+        const qreal dpr = devicePixelRatio();
+#else
+        const qreal dpr = 1.0; // Qt4: No device pixel ratio support
+#endif
         if (!qFuzzyCompare(dpr, 1.0))
             p.scale(1.0 / dpr, 1.0 / dpr);
         p.setClipRect(0, 0, imgW, imgH);
diff --git a/src/modules/QPainter/QPainterWriter.hpp b/src/modules/QPainter/QPainterWriter.hpp
index 0d7dea63..b2944d94 100644
--- a/src/modules/QPainter/QPainterWriter.hpp
+++ b/src/modules/QPainter/QPainterWriter.hpp
@@ -27,7 +27,7 @@
 class QPainterWriter;
 class QMPlay2OSD;
 
-class Drawable final : public QWidget
+class Drawable : public QWidget
 {
 public:
     Drawable(class QPainterWriter &);
@@ -35,25 +35,28 @@ public:
 
     void draw(const Frame &newVideoFrame, bool, bool);
 
-    void resizeEvent(QResizeEvent *) override;
+    void resizeEvent(QResizeEvent *);
 
     Frame videoFrame;
     QMPlay2OSDList osd_list;
     int Brightness, Contrast;
 private:
-    void paintEvent(QPaintEvent *) override;
-    bool event(QEvent *) override;
+    void paintEvent(QPaintEvent *);
+    bool event(QEvent *);
 
     int X, Y, W, H, imgW, imgH;
     QPainterWriter &writer;
     QImage img;
     ImgScaler imgScaler;
     bool m_scaleByQt = false;
+#if QT_VERSION < 0x050000
+    uint8_t *imgData = nullptr; // Qt4: Manual memory management
+#endif
 };
 
 /**/
 
-class QPainterWriter final : public VideoWriter
+class QPainterWriter : public VideoWriter
 {
     friend class Drawable;
 public:
@@ -61,19 +64,19 @@ public:
 private:
     ~QPainterWriter();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 
-    AVPixelFormats supportedPixelFormats() const override;
+    AVPixelFormats supportedPixelFormats() const;
 
-    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList) override;
+    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList);
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
     /**/
 
diff --git a/src/modules/Subtitles/Classic.cpp b/src/modules/Subtitles/Classic.cpp
index 3f219901..edb67f61 100644
--- a/src/modules/Subtitles/Classic.cpp
+++ b/src/modules/Subtitles/Classic.cpp
@@ -21,7 +21,7 @@
 #include <Functions.hpp>
 #include <LibASS.hpp>
 
-#include <QRegularExpression>
+#include <QRegExp>
 #include <QStringList>
 
 #include <algorithm>
@@ -70,7 +70,7 @@ static inline void initOnce(bool &ok, LibASS *ass)
     }
 }
 
-static inline QString convertLine(const QRegularExpression &rx, const QString &line)
+static inline QString convertLine(const QRegExp &rx, const QString &line)
 {
     return line.section(rx, 1, 1, QString::SectionIncludeTrailingSep).replace('|', '\n');
 }
@@ -100,14 +100,16 @@ bool Classic::toASS(const QByteArray &txt, LibASS *ass, double fps)
 
     bool ok = false, use_mDVD_FPS = Use_mDVD_FPS;
 
-    const QRegularExpression TMPRegExp(R"(\d{1,2}:\d{1,2}:\d{1,2}\D\s?)");
-    const QRegularExpression MPL2RegExp(R"(\[\d+\]\[\d*\]\s?)");
-    const QRegularExpression MicroDVDRegExp(R"(\{\d+\}\{\d*\}\s?)");
-    const QRegularExpression MicroDVDStylesRegExp(R"(\{(\w):(.*)\})", QRegularExpression::InvertedGreedinessOption);
+    // Qt4: Use QRegExp instead of QRegularExpression
+    const QRegExp TMPRegExp("\\d{1,2}:\\d{1,2}:\\d{1,2}\\D\\s?");
+    const QRegExp MPL2RegExp("\\[\\d+\\]\\[\\d*\\]\\s?");
+    const QRegExp MicroDVDRegExp("\\{\\d+\\}\\{\\d*\\}\\s?");
+    QRegExp MicroDVDStylesRegExp("\\{(\\w):(.*)\\}");
+    MicroDVDStylesRegExp.setMinimal(true);
 
     QList<SubWithoutEnd> subsWithoutEnd;
 
-    for (const QString &line : QString(txt).remove('\r').split('\n', Qt::SkipEmptyParts))
+    for (const QString &line : QString(txt).remove('\r').split('\n', QString::SkipEmptyParts))
     {
         double start = 0.0, duration = 0.0;
         QString sub;
@@ -166,7 +168,8 @@ bool Classic::toASS(const QByteArray &txt, LibASS *ass, double fps)
                 if (use_mDVD_FPS && (s == 0 || s == 1))
                 {
                     use_mDVD_FPS = false;
-                    const double newFPS = QStringView(sub).left(qMin(6, sub.size())).toDouble();
+                    // Qt4: No QStringView, use QString::left() directly
+                    const double newFPS = sub.left(qMin(6, sub.size())).toDouble();
                     if (newFPS > 0.0 && newFPS < 100.0)
                     {
                         fps = newFPS;
@@ -177,15 +180,14 @@ bool Classic::toASS(const QByteArray &txt, LibASS *ass, double fps)
                 int pos = 0;
                 for (;;)
                 {
-                    const auto match = MicroDVDStylesRegExp.match(sub, pos);
-                    if (!match.hasMatch())
+                    // Qt4: Use QRegExp::indexIn instead of match()
+                    pos = MicroDVDStylesRegExp.indexIn(sub, pos);
+                    if (pos == -1)
                         break;
 
-                    pos = match.capturedStart();
-
-                    const int matchedLength = match.capturedLength();
-                    const QString styleText = match.captured(2);
-                    const QChar s = match.captured(1).at(0);
+                    const int matchedLength = MicroDVDStylesRegExp.matchedLength();
+                    const QString styleText = MicroDVDStylesRegExp.cap(2);
+                    const QChar s = MicroDVDStylesRegExp.cap(1).at(0);
                     const bool singleLine = s.isLower();
                     switch (s.toLower().toLatin1())
                     {
@@ -251,7 +253,7 @@ bool Classic::toASS(const QByteArray &txt, LibASS *ass, double fps)
         }
 
         initOnce(ok, ass);
-        for (const SubWithoutEnd &sub : std::as_const(subsWithoutEnd))
+        for (const SubWithoutEnd &sub : subsWithoutEnd)
             ass->addASSEvent(Functions::convertToASS(sub.sub), sub.start, sub.duration);
     }
 
diff --git a/src/modules/Subtitles/Classic.hpp b/src/modules/Subtitles/Classic.hpp
index 2f5ca8ad..68e23ce8 100644
--- a/src/modules/Subtitles/Classic.hpp
+++ b/src/modules/Subtitles/Classic.hpp
@@ -20,12 +20,12 @@
 
 #include <SubsDec.hpp>
 
-class Classic final : public SubsDec
+class Classic : public SubsDec
 {
 public:
     Classic(bool, double);
 private:
-    bool toASS(const QByteArray &, class LibASS *, double) override;
+    bool toASS(const QByteArray &, class LibASS *, double);
 
     /**/
 
